-------------------------------------------------------------------------------------
-- Derby Lua Script
-- By Bidwars
-------------------------------------------------------------------------------------

local M = {}
--local removePartsFile = {} --Table of parts to remove
local startData = {}
M.vehInSaved = {}
local vehInSaved = {}
local driverList = {
		name = {"The Big Buffoon","Mayhem Mike","Gentle Bud","Sir NoMercy","Rawhide Billie","Cushion Charlie","Mr. Gumby","Ms. Gumby","Monster","Collision Carbonara","Motor Man Jackson","Erwin the Eliminator","Softcore James","Morning Hollywood","Crash Test Tommy","Hurricane Houston","MrBeast","PewDiePie","Jacksepticeye","Markiplier","DanTDM","TheWillyrex","rezendeevil","VanossGaming","JuegaGerman","Fernanfloo","ElRubiusOMG","The Game Theorists","LazarBeam","GameGrumps","H2ODelirious","CaptainSparklez","AngryJoeShow","CinnamonToastKen","Daithi De Nogla","Gappa"},
		number = {"01","02","03","04","05","06","07","08","09","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30","31","32","33","34","35","36","37"}
		}
local helper = require('scenario/scenariohelper')

local function addDriverInfo(i)
	local driverNumbers = {}
	local driverNames = {}
	local drivers = gdscenarios.options.players
	
	--Compare old vehicle list with M.vehIn list to see what change
	for _,v in ipairs(vehInSaved) do
		if v.driverName ~= nil then
			driverNames[v.driverName] = v.driverName
		end
		if v.driverNumber ~= 0 then
			driverNumbers[v.driverNumber] = v.driverNumber
		end
	end
	
	local dL = driverList
		
	local dNu
	local dNa
	
	local function getRandomName()
		if not dL.number[1] then
			local count = 99
			for i = 38, count do
				table.insert(dL.name, {'dRiVeR'..i})
				table.insert(dL.number, {i})
			end
			print('gdvehicles line 46 ran out of names')
		end
		dNa = dL.name[tableChooseRandomKey(dL.name)]
		for k,name in pairs(dL.name) do
			if name == dNa then
				dNu = dL.number[k]
				table.remove(dL.name,k)
				table.remove(dL.number,k)
			end
		end
	end
	for _,v in pairs(driverNames) do
		for k,name in pairs(dL.name) do
			if v == name then
				table.remove(dL.name,k)
				table.remove(dL.number,k)
			end
		end
	end	
	getRandomName()
	return  dNa, dNu

end
local function getPosRot(i)
	--print('pos and rotation '..i)
	local track = gdscenarios.options.tracks.selected
	if not startData[track] then
		local map = getMissionFilename():match('levels/([%w|_|%-|%s]+)/')
		local fn = string.format('levels/'..map..'/prefabs/StartPos.json')
		local file = {}
		if FS:fileExists(fn) then
			startData = readJsonFile(fn)
		else
			startData = {}
		end
	end
	local data = startData[track]
		if not data then 
			if i == 1 then 
				local pos = gdscenarios.startPos.pos
				local rot = gdscenarios.startPos.rot
				if not pos then
					local defaultSpawnPoint = setSpawnpoint.loadDefaultSpawnpoint()
					if defaultSpawnPoint then
						local spawnPoint = scenetree.findObject(defaultSpawnPoint)
						if spawnPoint then
							pos, rot = vec3(spawnPoint:getPosition()), quat(spawnPoint:getRotation()) * quat(0,0,1,0)
						end
					end
				end
				gdscenarios.startPos = {pos = pos, rot = rot}
				return  pos, rot 
			else
				local rot = gdscenarios.startPos.rot--quat(0, 0, 0, 0)
				local dir = vec3(0, -1, 0)
				local pos = vec3(0,0,0)
				
				local playerVehicleID = be:getPlayerVehicleID(0)
				for k, v in pairs(map.objects) do
					if k == playerVehicleID then
						dir = v.dirVec:normalized()
						--rot = quatFromDir(dir)
					end
				end
				local k = i - 1
				local playerVehicle = be:getObject(k)
				local offset = vec3(-dir.y, dir.x, 0)
				pos = vec3(playerVehicle:getPosition()) + offset * 5
				return pos , rot
			end
		end	
		local pos = {}
		local rot = {}
		for j,t in pairs(data) do
			j = tonumber(j)
			if j == i then
				pos = t.pos
				rot = t.rot
				rot = AngAxisF(rot.x, rot.y, rot.z, (rot.w * 3.1459) / 180.0 ):toQuatF()
				return pos, rot
			end
		end
end
--checks the vehIn table for invalid vehicles and deletes them
local function checkVehIn()
	local vehIn = gdscenarios.vehIn
	for k,v in pairs(vehIn) do
		local veh = be:getObjectByID(v.vid)
		if not veh then
			log('D','gdvehicles Delete Vehicle', 'Removing Vehicle From VehIn' ..vehIn[k].vid)
			table.remove(vehIn,k)
		end
	end
end
--unpaused
--1 normal loading
--2 paused scenario
--3 heats
-- 4 loading of heats feature
local function loadExtensions(unpaused)
	vehInSaved = {}
	local drivers = gdscenarios.options.players
	local vehIn = gdscenarios.vehIn
	local vehExclude = gdscenarios.options.tracks.objects
	local vehHeat = scenario_gdheats.vehHeat
	local currentHeat = scenario_gdheats.currentHeat
	if vehHeat and vehHeat > 0 and unpaused ~= 2 then
		print('vehHeat and loadextensions' ..unpaused .. ' should be set to 4')
		unpaused = 4
	end
	if unpaused ~= 4 and currentHeat and currentHeat > 1 and unpaused ~= 2 then
		print('vehHeat and loadextensions' ..unpaused .. ' should be set to 2')
		unpaused = 3
	end
	local count = be:getObjectCount() 
	local vcount = {}
	for i = 1, count do
		table.insert(vcount, i)
	end
	local i = 0
	for c = 1, count do
		local skip = false
		local rand = tableChooseRandomKey(vcount)
		local randvehnum = vcount[rand]
		table.remove(vcount,rand)
		local veh = be:getObject(c-1)
		if veh then
			local vid
			vid = veh:getID()
			if vid then
				if vehExclude and vehExclude[1] then
					for _,obj in pairs(vehExclude) do
						local name = veh:getField('JBeam','0')
						if obj == name then
							skip = true
							print('gdvehicels skip '.. name)
						end
					end
				end
				if not skip then
					i = i + 1
					if unpaused ~= 2 then
						local pos, rot = getPosRot(randvehnum)
						veh:setPositionRotation(pos.x, pos.y, pos.z, rot.x, rot.y, rot.z, rot.w)
						if unpaused == 4 then
							table.insert(vehInSaved, {vid = vid, driverNumber = vehIn[i].driverNumber, driverName = vehIn[i].driverName, model = gdscenarios.vehIn[i].model, pcs = gdscenarios.vehIn[i].pcs, device = gdscenarios.vehIn[i].device })
						elseif unpaused == 3 then
							local name, number = addDriverInfo()
							table.insert(vehInSaved, {vid = vid, driverNumber = number, driverName = name, model = gdscenarios.vehIn[i].model, pcs = gdscenarios.vehIn[i].pcs, device = drivers[i].device })
						else
							table.insert(vehInSaved, {vid = vid, driverNumber = drivers[i].number, driverName = drivers[i].name, model = gdscenarios.vehIn[i].model, pcs = gdscenarios.vehIn[i].pcs, device = drivers[i].device })
						end
					else
						--if they unpaused the scenario we check all the vehicles to see if some have been changed.
						local found = false
							--if vehIn[i] then
							for k, v in ipairs(vehIn) do
								if v.vid == vid then
								--print('gdvehicles '..v.vid .. '  '..vid)
									found = true
									local model = veh:getField('JBeam','0')
									local pcs = veh:getField('partConfig', '0')
									table.insert(vehInSaved, {vid = vid, driverNumber = vehIn[k].driverNumber, driverName = vehIn[k].driverName, model = model, pcs = pcs , device = vehIn[k].device })
									break
								end
							end
						--end
						if not found then
						--	local model = veh:getField('JBeam','0')
						--	local pcs = veh:getField('partConfig', '0')
						--	local driver, number = addDriverInfo()
						--	table.insert(vehInSaved, {vid = vid, driverNumber = number, driverName = driver, model = model, pcs = pcs, device = ''})
								
							log('D', 'scenario_gdvehicles', 'vehicle was not in vehIn Table.  This vehicle was counted out')
						end
					end
					helper.queueLuaCommand(veh, 'extensions.load("gdmain")')
				end
			else
				log('D', 'scenario_gdvehicles', 'loadExtensions vehicleid error')
			end
		else
			log('D', 'scenario_gdvehicles', 'loadExtensions vehicle error')
		end
	end
	gdscenarios.vehIn = vehInSaved
	checkVehIn()
	local playerID = gdscenarios.setPlayer(unpaused)
	--dump(gdscenarios.vehIn)
	scenario_gdletters.setSignText()
end
-----------------------------------------------------------------------------
--Gets the Model and Parts Config and saves them to a table for each vehicle that will spawn.
---------------------------------------------------------------------------------
local function getConfig(veh)
	local vehHeat = scenario_gdheats.vehHeat
	local model
	local pcs

	if vehHeat and vehHeat > 0 then
		local filename =  "vehicles/heats"..veh.."parts.pc"
		local save = jsonReadFile(filename)
		if not save then
			log("E", "save", "unable to get heats file")
			return
		end
		model = save.model
		pcs = save.pcs --fileparts
		table.insert(gdscenarios.vehIn, {vid = 0, driverNumber = save.driverNumber, driverName = save.driverName, model = model, pcs = pcs, device = save.device or ''})
	else 
		model, pcs = scenario_gdclasses.loadClass(veh)
		table.insert(gdscenarios.vehIn, {vid = 0, driverNumber = '0', driverName = '', model = model, pcs = pcs, device = ''})
	end
	return model, pcs
end
-------------------------------------------------------------------------------------
--CREATES THE VEHICLES FOR THE SCENARIO  
-------------------------------------------------------------------------------------
local function createVehicles()	
	local count =  gdscenarios.options.opponents + 1
	local vehHeat = scenario_gdheats.vehHeat
	if vehHeat and vehHeat > 0 then
		count = vehHeat
	end
	gdscenarios.vehIn = {}
	for i=1,count do
		--model is the vehicle type, and pcs is the parts Configuration
		local model, pcs = getConfig(i)
		--local color = string.format("%0.2f %0.2f %0.2f %0.2f", vehicle.color.x, vehicle.color.y, vehicle.color.z, vehicle.color.w)
		local options = {config = pcs}--, pos = position}
		core_vehicles.spawnNewVehicle(model, options)
	end
	loadExtensions(1)
end
local function onScenarioRestarted()
	M.vehInSaved = {}
end

M.onScenarioRestarted = onScenarioRestarted
M.loadExtensions = loadExtensions
M.loadPosition = loadPosition
M.createVehicles = createVehicles
M.getPosRot = getPosRot

return M